<?php
/**
 * Plugin Name: BestAzon
 * Plugin URI: http://BestAzonPlugin.com
 * Description: The only free plugin to automatically localize and affiliate-ize Amazon links. Add automatic amazon affiliate IDs to monetize your site, and localize your affiliate links to earn commissions from all Amazon stores globally.
 * Version: 1.6.0
 * Author: AwesomeAffiliatePlugins
 * Author URI: http://Support.BestAzonPlugin.com * License: GPL2
 */


function BestAzon_activate()
{
$options      = get_option('BestAzon_options');
if ($options['Conf_Tracking'] == 1) {
    $trackingurl = "https://docs.google.com/forms/d/1P9BZkncqfWwJY4iUc9p3GHqD3EMK8emFJ8y7qBEZblM/formResponse?entry.1249254641=" . get_site_url() . "&entry.1428077531=Activated&submit=Submit";
    $handle      = fopen($trackingurl, 'rb');
}
}
function BestAzon_deactivate()
{
$options      = get_option('BestAzon_options');
if ($options['Conf_Tracking'] == 1) {
    $trackingurl = "https://docs.google.com/forms/d/1P9BZkncqfWwJY4iUc9p3GHqD3EMK8emFJ8y7qBEZblM/formResponse?entry.1249254641=" . get_site_url() . "&entry.1428077531=Deactivated&submit=Submit";
    $handle      = fopen($trackingurl, 'rb');
}
}
register_activation_hook(__FILE__, 'BestAzon_activate');
register_deactivation_hook(__FILE__, 'BestAzon_deactivate');

add_action('wp_head', 'BestAzon_Initialization');
function BestAzon_Initialization()
{
    wp_enqueue_script('Jquery');
    wp_enqueue_script('BestAzon_Initialization_Script', plugins_url('js/BestAzon_Initialization_Script.js', __FILE__));
    $options = get_option('BestAzon_options');
    wp_localize_script('BestAzon_Initialization_Script', 'php_vars', $options);
    file_put_contents(dirname(__file__) . '/error_activation.txt', ob_get_contents());
}
// add the admin options page
add_action('admin_menu', 'BestAzon_admin_add_page');
function BestAzon_admin_add_page()
{
    add_options_page('BestAzon', 'BestAzon', 'manage_options', 'BestAzon', 'BestAzon_options_page');
}
// display the admin options page
function BestAzon_options_page()
{
    wp_enqueue_style(BestAzon - Style, plugins_url('css/BestAzon-Style.css', __FILE__));
wp_enqueue_script(BestAzon - AdminScript, plugins_url('js/BestAzon-AdminScript.js', __FILE__));
?>
<div class = "BestAzon-Options-Page">
<div class = "BestAzon-Header">
<h2>BestAzon Plugin</h2>
<p class = "BestAzon-HelpText">On this screen, you can configure the BestAzon plugin. </p>
</div>
<div class = "BestAzon-Form">
<form action="options.php" method="post">
<?php
    settings_fields('BestAzon_options');
    do_settings_sections('BestAzon');
    //submit_button();
?>
 
<input name="Submit" type="submit" value="<?php
    esc_attr_e('Save Changes');
?>" />
</form>
</div>
</div>
<?php
}
// add the admin settings and such
add_action('admin_init', 'BestAzon_admin_init');
function BestAzon_admin_init()
{
    register_setting('BestAzon_options', 'BestAzon_options', 'BestAzon_options_validate');
    add_settings_section('Amazon_setting', 'Amazon Settings', 'Amazon_setting_text', 'BestAzon');
    add_settings_section('Advanced_Configuration_setting', 'Advanced Configuration Settings', 'Advanced_Configuration_setting_text', 'BestAzon');
    add_settings_field('Amzn_AfiliateID_US', 'Amazon Affiiate ID - US Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_US',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-20"'
    ));
    add_settings_field('Amzn_AfiliateID_CA', 'Amazon Affiiate ID - Canada Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_CA',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-20"'
    ));
    add_settings_field('Amzn_AfiliateID_GB', 'Amazon Affiiate ID - UK Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_GB',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-21"'
    ));
    add_settings_field('Amzn_AfiliateID_DE', 'Amazon Affiiate ID - German Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_DE',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-21"'
    ));
    add_settings_field('Amzn_AfiliateID_FR', 'Amazon Affiiate ID - France Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_FR',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-21"'
    ));
    add_settings_field('Amzn_AfiliateID_ES', 'Amazon Affiiate ID - Spain Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_ES',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-21"'
    ));
    add_settings_field('Amzn_AfiliateID_IT', 'Amazon Affiiate ID - Italy Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_IT',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-21"'
    ));
    add_settings_field('Amzn_AfiliateID_JP', 'Amazon Affiiate ID - Japan Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_JP',
        'helper' => '',
        'placeholder' => 'Not Provided, should end with "-22"'
    ));
    add_settings_field('Amzn_AfiliateID_IN', 'Amazon Affiiate ID - India Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_IN',
        'helper' => '',
        'placeholder' => 'Not Provided'
    ));
    add_settings_field('Amzn_AfiliateID_CN', 'Amazon Affiiate ID - China Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_CN',
        'helper' => '',
        'placeholder' => 'Not Provided'
    ));
    add_settings_field('Amzn_AfiliateID_MX', 'Amazon Affiiate ID - Mexico Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_MX',
        'helper' => '',
        'placeholder' => 'Not Provided'
    ));
    add_settings_field('Amzn_AfiliateID_BR', 'Amazon Affiiate ID - Brazil Store', 'Amzn_AffiliateID_input', 'BestAzon', 'Amazon_setting', array(
        'optionkey' => 'Amzn_AfiliateID_BR',
        'helper' => '',
        'placeholder' => 'Not Provided'
    ));
    add_settings_field('Conf_Custom_Class', 'Please enter any custom class name you would like for the affiliate links', 'Amzn_AffiliateID_input', 'BestAzon', 'Advanced_Configuration_setting', array(
        'optionkey' => 'Conf_Custom_Class',
        'helper' => '',
        'placeholder' => 'Add custom classes (separated by space)'
    ));
    add_settings_field('Conf_New_Window', 'Open Links in New Window', 'Radio_button_input_3', 'BestAzon', 'Advanced_Configuration_setting', array(
        'optionkey' => 'Conf_New_Window',
        'defaultvalue' => '3'
    ));
    add_settings_field('Conf_Link_Follow', 'Make links no-follow for SEO', 'Radio_button_input_2', 'BestAzon', 'Advanced_Configuration_setting', array(
        'optionkey' => 'Conf_Link_Follow',
        'defaultvalue' => '2'
    ));
    add_settings_field('Conf_Donation', 'Donate this % of your traffic to BestAzon', 'Text_input', 'BestAzon', 'Advanced_Configuration_setting', array(
        'optionkey' => 'Conf_Donation',
        'helper' => '%',
        'placeholder' => 'Default: 0, Suggested: 5'
    ));
    add_settings_field('Conf_Tracking', 'Send usage information to list <span id="BestAzon_BlogName">' . get_bloginfo ('name') . ' </span>in our directory (SEO benefit)', 'Radio_button_input_2', 'BestAzon', 'Advanced_Configuration_setting', array(
        'optionkey' => 'Conf_Tracking',
	'supplemental' => 'We will get your site URL, and include in our site directory - potentially improving search engine ratings',
	'defaultvalue' => '2'
    ));
    add_settings_field('Conf_Footer', 'Include BestAzon credit below footer', 'Radio_button_input_2', 'BestAzon', 'Advanced_Configuration_setting', array(
        'optionkey' => 'Conf_Footer',
        'defaultvalue' => '2'
    ));
}
function Amazon_setting_text()
{
    echo '<p>Enter the affiliate ids for various Amazon marketplaces below. If you are not registered in any of these countries, please leave the box empty.</p>';
}
function Advanced_Configuration_setting_text()
{
    echo '<p> <span id="BestAzon_Recommendation"> CLICK HERE </span> to use recommended advanced settings, or if you know what you are doing you can change the advanced options in this section.</p>';
}
function Basic_Configuration_setting_text()
{
    echo '<p> Please let us know what you want!</p>';
}
function Amzn_AffiliateID_input(array $fieldkey)
{
    $options      = get_option('BestAzon_options');
    $fieldname    = $fieldkey['optionkey'];
    $defaultvalue = $fieldkey['defaultvalue'];
    $curentvalue  = $options[$fieldname];
    if (!$curentvalue && $defaultvalue != FALSE) {
        $options[$fieldname] = $defaultvalue;
    }
    $placeholder = $fieldkey['placeholder'];
    echo "<input id='$fieldname' placeholder='$placeholder' name='BestAzon_options[$fieldname]' size='40' type='text' value='{$options[$fieldname]}' />";
    // If there is help text
    if ($helper = $fieldkey['helper']) {
        printf('<span class="helper"> %s</span>', $helper); // Show it
    }
    // If there is supplemental text
    if ($supplimental = $fieldkey['supplemental']) {
        printf('<p class="description">%s</p>', $supplimental); // Show it
    }
}
function Text_Input(array $fieldkey)
{
    $options     = get_option('BestAzon_options');
    $fieldname   = $fieldkey['optionkey'];
    $placeholder = $fieldkey['placeholder'];
    echo "<input id='$fieldname' placeholder='$placeholder' name='BestAzon_options[$fieldname]' size='40' type='text' value='{$options[$fieldname]}' />";
    // If there is help text
    if ($helper = $fieldkey['helper']) {
        printf('<span class="helper"> %s</span>', $helper); // Show it
    }
    // If there is supplemental text
    if ($supplimental = $fieldkey['supplemental']) {
        printf('<p class="description">%s</p>', $supplimental); // Show it
    }
}
// validate our options
function BestAzon_options_validate($input)
{
    $options = $input;
    return $options;
}
function Radio_button_input_3(array $fieldkey)
{
    $options      = get_option('BestAzon_options');
    $fieldname    = $fieldkey['optionkey'];
    $defaultvalue = $fieldkey['defaultvalue'];
    $curentvalue  = $options[$fieldname];
    if (!$curentvalue && $defaultvalue != FALSE) {
        $options[$fieldname] = $defaultvalue;
    }
    $id_yes        = $fieldname . "-Yes";
    $id_no         = $fieldname . "-No";
    $id_default    = $fieldname . "-Default";
    $current_value = $options[$fieldname];
    $html          = "<input type='radio' id='$id_yes'  name='BestAzon_options[$fieldname]' value='1' " . (($current_value == 1) ? 'checked' : '') . "/>";
    $html .= "<label for='$id_yes'>Yes</label>";
    $html .= "<input type='radio' id='$id_no'  name='BestAzon_options[$fieldname]' value='2' " . (($current_value == 2) ? 'checked' : '') . "/>";
    $html .= "<label for='$id_no'>No</label>";
    $html .= "<input type='radio' id='$id_default'  name='BestAzon_options[$fieldname]' value='3' " . (($current_value == 3) ? 'checked' : '') . "/>";
    $html .= "<label for='$id_default'>Use original setting in the link</label>";
    echo $html;
// If there is help text
    if ($helper = $fieldkey['helper']) {
        printf('<span class="helper"> %s</span>', $helper); // Show it
    }
    // If there is supplemental text
    if ($supplimental = $fieldkey['supplemental']) {
        printf('<p class="description">%s</p>', $supplimental); // Show it
    }
}
function Radio_button_input_2(array $fieldkey)
{
    $options      = get_option('BestAzon_options');
    $fieldname    = $fieldkey['optionkey'];
    $defaultvalue = $fieldkey['defaultvalue'];
    $curentvalue  = $options[$fieldname];
    if (!$curentvalue && $defaultvalue != FALSE) {
        $options[$fieldname] = $defaultvalue;
    }
    $id_yes        = $fieldname . "-Yes";
    $id_no         = $fieldname . "-No";
    $id_default    = $fieldname . "-Default";
    $current_value = $options[$fieldname];
    $html          = "<input type='radio' id='$id_yes'  name='BestAzon_options[$fieldname]' value='1' " . (($current_value == 1) ? 'checked' : '') . "/>";
    $html .= "<label for='$id_yes'>Yes</label>";
    $html .= "<input type='radio' id='$id_no'  name='BestAzon_options[$fieldname]' value='2' " . (($current_value == 2) ? 'checked' : '') . "/>";
    $html .= "<label for='$id_no'>No</label>";
    echo $html;
// If there is help text
    if ($helper = $fieldkey['helper']) {
        printf('<span class="helper"> %s</span>', $helper); // Show it
    }
    // If there is supplemental text
    if ($supplimental = $fieldkey['supplemental']) {
        printf('<p class="description">%s</p>', $supplimental); // Show it
    }
}

Is_Affiliate_ID_Filled();
function Is_Affiliate_ID_Filled()
{
    $Affiliate_ID_Count = 0;
    $options            = get_option('BestAzon_options');
if (is_array($options) || is_object($options))
{
    foreach ($options as $key => $value) {
        if (strpos($key, "Amzn") !== FALSE) {
            if ($options[$key] !== "") {
                $Affiliate_ID_Count = $Affiliate_ID_Count + 1;
            }
        }
    }
}
    if ($Affiliate_ID_Count == "0") {
        // echo "<script> console.log(" . $Affiliate_ID_Count . "); </script>";
        add_action('admin_notices', 'BestAzon_NoAffiliateID_notice');
    }
}
function BestAzon_NoAffiliateID_notice()
{
?>
  <div class="BestAzon_Admin_Notice notice notice-warning">
      <p><?php
    _e('You have not provided any Amazon Affiliate ID in your BestAzon setting. Please provide the information so that we can add you affiliate tags', 'BestAzon_textdomain');
?></p>
  </div>
<?php
}
function BestAzon_footer_credit()
{
    $options = get_option('BestAzon_options');
    if ($options['Conf_Footer'] == 1) {
        echo '<a style="color: transparent; font-size: 1px" href="http://BestAzonPlugin.com">Amazon Link Localization Courtesy BestAzon</a>';
    }
}
add_action('wp_footer', 'BestAzon_footer_credit', 100);
?>